=== debian/changelog ===
cpputest (3.7.2-1) unstable; urgency=medium

  * New upstream release that drops the test that fails on arm64, powerpc,
    ppc64el. Closes: #784674
  * Use "make tdd" to run the test suite as it is more verbose.

 -- Raphaël Hertzog <hertzog@debian.org>  Mon, 11 May 2015 09:57:27 +0200
