=== debian/control ===
Source: cpputest
Section: devel
Priority: optional
Maintainer: Raphaël Hertzog <hertzog@debian.org>
Homepage: http://cpputest.github.io/
Vcs-Git: git://anonscm.debian.org/collab-maint/cpputest.git
Vcs-Browser: http://anonscm.debian.org/cgit/collab-maint/cpputest.git
Standards-Version: 3.9.6
Build-Depends: debhelper (>= 9.20120608~), dh-autoreconf

Package: cpputest
Architecture: all
Multi-Arch: foreign
Depends: libcpputest-dev, ${misc:Depends}
Suggests: ruby | ruby-interpreter
Description: C/C++ based unit test framework — main package
 CppUTest is a C/C++ based unit xUnit test framework for unit testing and
 for test-driving your code. It is written in C++ but is used in C and C++
 projects and frequently used in embedded systems.
 .
 CppUTest has a couple design principles:
  * Simple to use and small
  * Portable to old and new platforms
 .
 CppUTest also has support for building mocks and can be used by
 practitioners of Test Driven Development.
 .
 This is the main package. It contains some examples, support scripts
 and depends on libcpputest-dev which provides the test framework
 itself.

Package: libcpputest-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: C/C++ based unit test framework — headers and static libraries
 CppUTest is a C/C++ based unit xUnit test framework for unit testing and
 for test-driving your code. It is written in C++ but is used in C and C++
 projects and frequently used in embedded systems.
 .
 CppUTest has a couple design principles:
  * Simple to use and small
  * Portable to old and new platforms
 .
 CppUTest also has support for building mocks and can be used by
 practitioners of Test Driven Development.
 .
 This is the package with the headers and the static libraries implementing
 the test framework.
