=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --with autoreconf

override_dh_auto_configure:
	dh_auto_configure -- --disable-silent-rules

override_dh_auto_test:
	$(MAKE) tdd

override_dh_compress:
	dh_compress -X.cpp

# Fixes for the cpputest (arch-all) package
override_dh_installexamples-indep:
	dh_installexamples
	chmod 644 debian/cpputest/usr/share/doc/cpputest/examples/*.dsw

override_dh_fixperms-indep:
	chmod 755 debian/cpputest/usr/share/cpputest/scripts/NewProject.sh \
		  debian/cpputest/usr/share/cpputest/scripts/convertToUnity/create_unity_test_runner.rb
	dh_fixperms

# Be explicit about "build" being a virtual target since it's a real directory
.PHONY: build
