=== debian/watch ===
version=3
opts=downloadurlmangle=s/$/?raw=true/ \
https://github.com/cpputest/cpputest.github.io/tree/master/releases \
 .*/releases/[Cc]pp[Uu][Tt]est-v?(\d[\d.]*)\.tar\.gz
