## cpputest 3.7.2+dfsg

=== debian/changelog ===
cpputest (3.7.2+dfsg-1) unstable; urgency=medium

  * Repackage upstream tarball to drop platforms* directories containing
    some non-free files. Closes: #823711
  * Update Standards-Version to 3.9.8.
  * Update Vcs-Git and Vcs-Browser to use https URLs.

 -- Raphaël Hertzog <hertzog@debian.org>  Mon, 09 May 2016 22:15:27 +0200
