=== debian/changelog ===
cpputest (3.8-7) unstable; urgency=medium

  * Update Vcs-* fields in light of move to salsa.

 -- Raphaël Hertzog <hertzog@debian.org>  Mon, 05 Feb 2018 20:37:15 +0100

cpputest (3.8-6) unstable; urgency=medium

  * Add explicit "build" target in debian/rules due to the existence of a
    "build" directory in the upstream files. Closes: #888598
  * Switch to debhelper 11.
  * Bump Standards-Version to 4.1.3.
  * Do not run test suite if DEB_BUILD_OPTIONS contains nocheck.

 -- Raphaël Hertzog <hertzog@debian.org>  Mon, 05 Feb 2018 18:56:17 +0100

cpputest (3.8-5) unstable; urgency=medium

  * No longer build the static library with -fPIC. -fPIE is enabled by
    default at the gcc level and it's enough. Closes: #842105

 -- Raphaël Hertzog <hertzog@debian.org>  Wed, 02 Nov 2016 18:44:24 +0100

cpputest (3.8-4) unstable; urgency=medium

  * Build static libraries with -fPIC so that executables linked against
    CppUTest can be built with -fPIE. Closes: #837363

 -- Raphaël Hertzog <hertzog@debian.org>  Wed, 14 Sep 2016 11:13:00 +0200

cpputest (3.8-3) unstable; urgency=medium

  * Add new patch to fix builds on armel, m68k, s390x, ppc64 and sparc64.

 -- Raphaël Hertzog <hertzog@debian.org>  Fri, 17 Jun 2016 23:34:37 +0200

cpputest (3.8-2) unstable; urgency=medium

  * Properly install files generated by make install. Closes: #827279
  * Add a patch to install include/CppUTestExt/CodeMemoryReportFormatter.h
  * Add DEP-8 test suite to ensure that the package works fine.

 -- Raphaël Hertzog <hertzog@debian.org>  Wed, 15 Jun 2016 14:17:11 +0200

cpputest (3.8-1) unstable; urgency=medium

  * New upstream release.
  * No longer repack upstream tarball as problematic files have been dropped
    upstream.
  * Update watch file to track new location in main github repository.

 -- Raphaël Hertzog <hertzog@debian.org>  Mon, 13 Jun 2016 23:00:06 +0200
