=== debian/control ===
--- 
+++ 
@@ -3,10 +3,10 @@
 Priority: optional
 Maintainer: Raphaël Hertzog <hertzog@debian.org>
 Homepage: http://cpputest.github.io/
-Vcs-Git: git://anonscm.debian.org/collab-maint/cpputest.git
-Vcs-Browser: http://anonscm.debian.org/cgit/collab-maint/cpputest.git
-Standards-Version: 3.9.6
-Build-Depends: debhelper (>= 9.20120608~), dh-autoreconf
+Vcs-Git: https://salsa.debian.org/debian/cpputest.git
+Vcs-Browser: https://salsa.debian.org/debian/cpputest
+Standards-Version: 4.1.3
+Build-Depends: debhelper (>= 11)
 
 Package: cpputest
 Architecture: all
