=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

# The build target must not be empty because it's also a real directory
# (see #888598).
.PHONY: build
build:
	dh $@

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	$(MAKE) tdd
endif

override_dh_compress:
	dh_compress -X.cpp

override_dh_missing:
	dh_missing --fail-missing

# Fixes for the cpputest (arch-all) package
override_dh_installexamples-indep:
	dh_installexamples
	chmod 644 debian/cpputest/usr/share/doc/cpputest/examples/*.dsw

override_dh_fixperms-indep:
	chmod 755 debian/cpputest/usr/share/cpputest/scripts/NewProject.sh \
		  debian/cpputest/usr/share/cpputest/scripts/convertToUnity/create_unity_test_runner.rb
	dh_fixperms
