=== debian/tests/control ===
Tests: build-and-run-upstream-testsuite
Restrictions: allow-stderr
Depends: libcpputest-dev, g++, pkg-config
